﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage<Models.MaintenanceSportsGridSportViewModel>" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
    Sport Page
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">

    <div>
    <%
        Html.Kendo().Window()
        .Name("CommentWindow")
        .Title("set by javascript")
        .Content(() =>
            { 
                    Html.Kendo().Editor()
                        .Name("editorWindowComments")
                        .Tools(t => t.Clear())
                        .Value("")
                        .HtmlAttributes(new { style = "height:300px" })
                        .Render();

                        %> 
                        <input type="hidden" name="primaryKey" value="" />
                        <input type="hidden" name="tableName" value="" />

<%--                        <div style="text-align:right;margin: 5px 0px 0px 0px;">
                            <input id="saveCommentsButton" type="button" value="Save" onclick="updateComments()" />
                        </div>
--%>
            <%})
        .Draggable(true)
        .Scrollable(false)
        .Resizable()
        //.Buttons(b => b.Close())
        .Width(900) /* editor toolbar gets on one line */
        .Height(350) /* accomodates editor height */
        .Modal(true)
        .Visible(false) /* window not visible on initial load */
        .Render();
                        
    %>
    </div>

    <div style="float:left; width:100%;">

        <% Html.Kendo().Grid<Models.MaintenanceSportsGridSportViewModel>()
            .Name("Sports")
            .TableHtmlAttributes(new { style = "font-size:8pt;" })
            .HtmlAttributes(new { style = "height:520px;width:1120px" })
            .DataSource(dataSource => dataSource
                    .Ajax()
                    .Model(model => model.Id(a => a.SportId))
                    .ServerOperation(true)
                    .Read(read => read.Action("MaintenanceSportsAjax", "Home"))
                    .Update(update => update.Action("UpdateMaintenanceSports", "Home").Data("onUpdateMaintenanceSports"))
                    .Events(a => a.RequestEnd("onMaintenanceSportsGridRequestEnd"))
                    .PageSize(13)
                )
            .Editable(e => e.Mode(Kendo.Mvc.UI.GridEditMode.InLine).Enabled(true))
            .Events(e => e.DataBound("onMaintenanceSportsRowDataBound")
                          .Edit("onEditMaintenanceSports")
                          .Save("onSaveMaintenanceSports")
                    )
            .Pageable(pager => pager.Input(true)
                                    .Refresh(true)
                                    .PageSizes(new[] { 13, 20, 30 })
                    )
            .Scrollable(scrolling => scrolling.Height(500))
            //.Resizable(resize => resize.Columns(true))
            .Sortable()
            .Filterable()
            .ClientDetailTemplateId("DisciplinesTemplate")
            .Columns(columns =>
            {
                columns.Bound(s => s.SportCode).Width(70);
                columns.Bound(s => s.Name).Width(140);
                columns.Bound(s => s.Gender)
                    .Width(70)
                    .HtmlAttributes(new { style = "text-align:center" });
               columns.Bound(s => s.NSOName)
                    .Width(200);
                columns.Bound(s => s.HPAName)
                    .Width(120);
                columns.Bound(s => s.Benchmark)
                    .HeaderHtmlAttributes(new { title = "Benchmark" })
                    .ClientTemplate("# if (Benchmark == true) { #" + "<div class='sprite sprite-tick'></div>" + "# } #")
                    .Width(60)
                    .HtmlAttributes(new { style = "text-align:center" });
                columns.Bound(s => s.MedalEvent)
                    .HeaderHtmlAttributes(new { title = "Medal Event" })
                    .ClientTemplate("# if (MedalEvent == true) { #" + "<div class='sprite sprite-tick'></div>" + "# } #")
                    .Width(60)
                    .HtmlAttributes(new { style = "text-align:center" });
                columns.Bound(s => s.Ranking)
                    .Width(70);
                columns.Bound(s => s.HasComments)
                    .HeaderHtmlAttributes(new { title = "Comments" })
                    .ClientTemplate("<div class='sprite sprite-note commentWindow'></div>")
                    .HtmlAttributes(new { style = "text-align:center" })
                    .Width(50);
                columns.Command(commands =>
                {
                    commands.Edit();
                })
                .Width(160)
                .Title("Commands");
            }).Render();
            
        %>

        <br />
        <br />

    </div>
    <script id="DisciplinesTemplate" type="text/x-kendo-template">

        <%: Html.Kendo().Grid<Models.MaintenanceSportsGridDisciplineViewModel>()
            .Name("Sports_#=SportId#")
            .HtmlAttributes(new { Style = "width:1050px" })
            .DataSource(dataSource => dataSource
                    .Ajax()
                    .Model(model => model.Id(a => a.DisciplineId))
                    .ServerOperation(false)
                    .Events(e => e.RequestEnd("onMaintenanceDisciplinesRequestEnd"))
                    .Create(create => create.Action("InsertMaintenanceDisciplines", "Home", new { parentSportId = "#=SportId#" }))
                    .Read(read => read.Action("MaintenanceDisciplinesAjax", "Home", new { sportId = "#=SportId#" }))
                    .Update(update => update.Action("UpdateMaintenanceDisciplines", "Home").Data("onUpdateMaintenanceDisciplines"))
                    .Destroy(destroy => destroy.Action("DeleteMaintenanceDisciplines", "Home").Data("onUpdateMaintenanceDisciplines"))
                )
            .ToolBar(toolbar =>
                {
                    toolbar.Create();
                })
            .Editable(e => e.Mode(Kendo.Mvc.UI.GridEditMode.InLine).Enabled(true))
            .Events(e => e.DataBound("onMaintenanceDisciplinesRowDataBound")
                          .Edit("onEditMaintenanceDisciplines")
                          .Save("onSaveMaintenanceDisciplines")
               )
            .Pageable(pager => pager.Input(true)
                                    .Refresh(true)
                                    .PageSizes(new[] { 10, 20, 30 })
                )
            .Sortable()
            .Resizable(resize => resize.Columns(true))
            .Filterable()
            .ClientDetailTemplateId("EventsTemplate")
            .Columns(columns =>
            {
                columns.Bound(b => b.SportCode)
                    .Width(70);
                columns.Bound(b => b.Name_EN)
                    .Width(200);
                columns.Bound(b => b.Name_FR)
                    .Width(200);
                columns.Bound(b => b.Gender)
                    .Width(80)
                    .HtmlAttributes(new { style = "text-align:center" });                
                columns.Bound(b => b.Benchmark)
                    .ClientTemplate("# if (Benchmark == true) { #" + "<div class='sprite sprite-tick'></div>" + "# } #")
                    .Width(85)
                    .HtmlAttributes(new { style = "text-align:center" });
                columns.Bound(b => b.MedalEvent)
                    .HeaderHtmlAttributes(new { title = "Medal Event" })
                    .ClientTemplate("# if (MedalEvent == true) { #" + "<div class='sprite sprite-tick'></div>" + "# } #")
                    .Width(85)
                    .HtmlAttributes(new { style = "text-align:center" });
                columns.Bound(s => s.HasComments)
                    .HeaderHtmlAttributes(new { title = "Comments" })
                    .ClientTemplate("<div class='sprite sprite-note commentDisciplineWindow'></div>")
                    .HtmlAttributes(new { style = "text-align:center" })
                    .Width(60);
                columns.Command(commands =>
                {
                    commands.Edit();
                    commands.Destroy();
                })
                .Width(175);
            })
            .ToClientTemplate()          

      %>      

    </script>

    <script id="EventsTemplate" type="text/x-kendo-template">

        <%: Html.Kendo().Grid<Models.MaintenanceSportsGridEventViewModel>()
            .Name("Events#=DisciplineId#")
            .HtmlAttributes(new { Style = "width:1000px" })
            .DataSource(dataSource => dataSource
                    .Ajax()
                    .Model(model => model.Id(a => a.EventId))
                    .ServerOperation(false)
                    .Events(e => e.RequestEnd("onMaintenanceEventsRequestEnd"))
                    .Create(create => create.Action("InsertMaintenanceEvents", "Home", new { parentDisciplineId = "#=DisciplineId#" }))
                    .Read(read => read.Action("MaintenanceEventsAjax", "Home", new { disciplineId = "#=DisciplineId#" }))
                    .Update(update => update.Action("UpdateMaintenanceEvents", "Home").Data("onUpdateMaintenanceEvents"))
                    .Destroy(destroy => destroy.Action("DeleteMaintenanceEvents", "Home").Data("onUpdateMaintenanceEvents"))
                )
            .ToolBar(toolbar =>
                {
                    toolbar.Create();
                })
            .Editable(e => e.Mode(Kendo.Mvc.UI.GridEditMode.InLine).Enabled(true))
            .Events(e => e.DataBound("onMaintenanceEventsRowDataBound")
                          .Edit("onEditMaintenanceEvents")
                )
            .Pageable(pager => pager.Input(true)
                                    .Refresh(true)
                                    .PageSizes(new[] { 10, 20, 30 })
                )
            .Sortable()
            .Resizable(resize => resize.Columns(true))
            .Filterable()
            .Columns(columns =>
            {
                columns.Bound(b => b.SportCode)
                    .Width(60);
                columns.Bound(b => b.Name_EN)
                    .Width(150);
                columns.Bound(b => b.Name_FR)
                    .Width(150);
                columns.Bound(b => b.Benchmark)
                    .ClientTemplate("# if (Benchmark == true) { #" + "<div class='sprite sprite-tick'></div>" + "# } #")
                    .Width(60)
                    .HtmlAttributes(new { style = "text-align:center" });
                columns.Bound(b => b.MedalEvent)
                    .HeaderHtmlAttributes(new { title = "Medal Event" })
                    .ClientTemplate("# if (MedalEvent == true) { #" + "<div class='sprite sprite-tick'></div>" + "# } #")
                    .Width(80)
                    .HtmlAttributes(new { style = "text-align:center" });
                columns.Bound(b => b.TeamSport)
                    .ClientTemplate("# if (data.TeamSport == true) { #" + "<div class='sprite sprite-tick'></div>" + "# } #")
                    .Width(60)
                    .HtmlAttributes(new { style = "text-align:center" });
                columns.Bound(b => b.TeamSize)
                    .Width(70)
                    .HtmlAttributes(new { style = "text-align:center" });
                columns.Bound(b => b.ResourceTracking)
                    .ClientTemplate("# if (data.ResourceTracking == true) { #" + "<div class='sprite sprite-tick'></div>" + "# } #")
                    .Width(80)
                    .HtmlAttributes(new { style = "text-align:center" });
                columns.Bound(s => s.HasComments)
                    .HeaderHtmlAttributes(new { title = "Comments" })
                    .ClientTemplate("<div class='sprite sprite-note commentEventWindow'></div>")
                    .Width(40);
                columns.Command(commands =>
                {
                    commands.Edit();
                    commands.Destroy();
                })
                .Width(175)
                .HtmlAttributes(new { style = "white-space:nowrap;float:right;" });
            })
            .ToClientTemplate()          

      %>      
    </script>

    <script type="text/javascript">

        $("#Sports").on("click", ".commentWindow", function (e) {
            var grid = $("#Sports").data("kendoGrid");
            var model = grid.dataItem($(e.target).closest("tr"));
            var sportId = model.SportId;
            var sportCode = model.SportCode;

            var editable = 'true';
            openCommentWindow('Sport', sportId, sportCode, editable, 'true');
        });

        $("#Sports").on("click", ".commentDisciplineWindow", function (e) {
//            var grid = $("#Sports_#=SportId#").data("kendoGrid");
            var grid = $(this).closest(".k-grid").data("kendoGrid");
             var model = grid.dataItem($(e.target).closest("tr"));
            var disciplineId = model.DisciplineId;
            var sportCode = model.SportCode;

            var editable = 'true';
            openCommentWindow('Discipline', disciplineId, sportCode, editable, 'true');
        });

        function onMaintenanceSportsRowDataBound(e) {

            return;
        }

        function onEditMaintenanceSports(e) {

            if (e.model.isNew()) {
                var update = $(e.container).parent().find(".k-grid-update");
                $(update).html('<span class="k-icon k-update"></span>Insert');
            }
        }

        function onSaveMaintenanceSports(e) {

        }

        function onUpdateMaintenanceSports(e) {
            return { sportId: e.SportId }
        }

        function onMaintenanceSportsGridRequestEnd(e) {
            if (e.type == "create" || e.type == "update" || e.type == "destroy") {
                this.read();
            }
        }

        function onMaintenanceDisciplinesRowDataBound(e) {

            return;
        }

        function onUpdateMaintenanceDisciplines(e) {
            return { id: e.DisciplineId }
        }

        function onMaintenanceDisciplinesRequestEnd(e) {
            if (e.type == "create" || e.type == "update" || e.type == "destroy") {
                this.read();
            }
        }

        function onEditMaintenanceDisciplines(e) {

            if (e.model.isNew()) {
                var update = $(e.container).parent().find(".k-grid-update");
                $(update).html('<span class="k-icon k-update"></span>Insert');
            }
            else {
                var dropdownlist = $("#Gender").data("kendoDropDownList");
                var gender = e.model.Gender;
                if (gender == "F") {
                    gender = "Female";
                }
                else if (gender == "M") {
                    gender = "Male";
                }
                else {
                    gender = "Combined";
                }

                dropdownlist.value(gender);
                dropdownlist.refresh();

            }
        }

        function onSaveMaintenanceDisciplines(e) {

            var gender = $("#Gender").data("kendoDropDownList").value();

            if (gender == "Female") {
                gender = "F";
            }
            else if (gender == "Male") {
                gender = "M";
            }
            else {
                gender = "C";
            }

            e.model.Gender = gender;

        }

        function onMaintenanceEventsRowDataBound(e) {
        }

        function onUpdateMaintenanceEvents(e) {
            return { id: e.EventId }
        }

        function onMaintenanceEventsRequestEnd(e) {
            if (e.type == "create" || e.type == "update" || e.type == "destroy") {
                this.read();
            }
        }

        function onEditMaintenanceEvents(e) {

            if (e.model.isNew()) {
                var update = $(e.container).parent().find(".k-grid-update");
                $(update).html('<span class="k-icon k-update"></span>Insert');
            }
        }

        function openCommentWindow(tableName, primaryKey, windowTitle, editableGrid, editableRow) {

            var editable = (editableGrid.toLowerCase() == 'true' && editableRow.toLowerCase() == 'true');

            if (windowTitle === "") {
                windowTitle = "Comment";
            }
            else {
                windowTitle = "Comment - " + windowTitle;
            }

//            if (editable) {
//                $("#saveCommentsButton").removeAttr('disabled');
//            }
//            else {
//                $("#saveCommentsButton").attr('disabled', 'disabled');
//            }

            //Force ajax to retrieve new data each call
            var d = new Date();
            var refreshSeed = d.getTime();

//            $.getJSON("/Shared/GetComments", { primaryKey: primaryKey, tableName: tableName, refresh: refreshSeed }, function (comments) {
//                var cleanComments = unescape(comments);
                $("#CommentWindow").data("kendoWindow").title(windowTitle);

                $("#CommentWindow")
                    .find('input[name=primaryKey]').val(primaryKey).end()
                    .find('input[name=tableName]').val(tableName).end()
                    .data("kendoWindow").center().open();

//                $("#editorWindowComments").data("kendoEditor").value(cleanComments);
//            });
        }

    </script>

</asp:Content>

<asp:Content ID="Content3" ContentPlaceHolderID="FeaturedContent" runat="server">
</asp:Content>
