﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.DataAnnotations;

namespace Models
{
    //[Serializable]
    //public class MaintenanceAthletesAthleteGridViewModel
    //{
    //    public int ResourceId { get; set; }

    //    public string LastName { get; set; }

    //    public string FirstName { get; set; }

    //    public string CountryId { get; set; }

    //    public string CountryName { get; set; }

    //    public string GenderId { get; set; }

    //    public string GenderName { get; set; }

    //    public string BirthDate { get; set; }

    //    public DateTime? DateOfBirth { get; set; }

    //    public bool TBD { get; set; }

    //    public bool IsNew { get; set; }

    //    public bool BenchmarksEntered { get; set; }

    //    public bool Pooled { get; set; }

    //    public string Category { get; set; }

    //    public string ResourceSpecialtyId { get; set; }

    //    public string ResourceSpecialtyName { get; set; }

    //    public int? PersonalCoachId { get; set; }

    //    public string PersonalCoachName { get; set; }

    //    public string CoachFirstName { get; set; }

    //    public string CoachLastName { get; set; }

    //    public string AssignSportId { get; set; }
    //}

    //[Serializable]
    //public class MaintenanceAthletesSportsInfoViewModel
    //{
    //    public int ResourceId { get; set; }

    //    public int ResourceSportId { get; set; }

    //    public string SportsId { get; set; }

    //    public string SportName { get; set; }

    //    public string DisciplineId { get; set; }

    //    public string DisciplineName { get; set; }

    //    public string EventId { get; set; }

    //    public string EventName { get; set; }

    //    public string YearId { get; set; }

    //    public string ResourceClassId { get; set; }

    //    public string ResourceClassName { get; set; }

    //    public int? EventCoachId { get; set; }

    //    public string EventCoachName { get; set; }

    //    public string SportTrackingRef { get; set; }

    //    public bool Benchmark { get; set; }

    //    public bool HasComments { get; set; }

    //    public string CoachLastName { get; set; }

    //    public string CoachFirstName { get; set; }
    //}

    //[Serializable]
    //public class MaintenanceAthletesBenchmarkSportsViewModel
    //{
    //    public int BenchmarkResourceId { get; set; }

    //    public string ResourceId { get; set; }

    //    public int ResourceSportId { get; set; }

    //    public int BenchmarkTypeId { get; set; }

    //    //[UIHint("AthletesSportsInfoBenchmarkTypeTemplate")]
    //    public string BenchmarkTypeName { get; set; }

    //    public int BenchmarkTierId { get; set; }

    //    //[UIHint("AthletesSportsInfoBenchmarkTierTemplate")]
    //    public string BenchmarkTierName { get; set; }

    //    public string YearId { get; set; }

    //    public int? OTPValue { get; set; }

    //    public int? NSOValue { get; set; }

    //    public bool HasComments { get; set; }

    //    public bool Active { get; set; }
    //}

    //[Serializable]
    //public class MaintenanceAthletesGeneralInfoViewModel
    //{
    //    public int ResourceId { get; set; }

    //    public string FirstName { get; set; }

    //    public string LastName { get; set; }

    //    public string CountryId { get; set; }

    //    public string Gender { get; set; }

    //    private DateTime? _dateOfBirth;

    //    public DateTime? DateOfBirth
    //    {
    //        get
    //        {
    //            if (_dateOfBirth == null)
    //            {
    //                return _dateOfBirth;
    //            }
    //            else
    //            {
    //                var dob = (DateTime)_dateOfBirth;
    //                return DateTime.SpecifyKind(new DateTime(dob.Year, dob.Month, dob.Day), DateTimeKind.Utc);
    //            }
    //        }
    //        set
    //        {
    //            _dateOfBirth = value;
    //            if (value != null)
    //            {
    //                var dob = (DateTime)value;
    //                _dateOfBirth = DateTime.SpecifyKind(new DateTime(dob.Year, dob.Month, dob.Day), DateTimeKind.Utc);
    //            }
    //        }
    //    }

    //    public string DateOfBirthLiteral
    //    {
    //        get
    //        {
    //            return _dateOfBirth == null ? "" : ((DateTime)DateOfBirth).ToShortDateString();
    //        }
    //    }

    //    public string PrimaryCSCId { get; set; }

    //    public string SecondaryCSCId { get; set; }

    //    public bool TBD { get; set; }

    //    public bool Pooled { get; set; }

    //    public bool IsNew { get; set; }

    //    public bool Active { get; set; }

    //    public string Comments { get; set; }

    //    public int? PersonalCoachId { get; set; }

    //    public List<ListItem> Countries { get; set; }

    //    public List<ListItem> Genders { get; set; }

    //    public List<ListItem> CSCs { get; set; }

    //    public List<ListItem> CoachResources { get; set; }

    //}

    [Serializable]
    public class MaintenanceSportsGridSportViewModel
    {
        public string SportId { get; set; }

        public string Name { get; set; }

        public string SportCode { get; set; }

        public string Gender { get; set; }

        public bool Benchmark { get; set; }

        public bool MedalEvent { get; set; }

        public string HPAID { get; set; }

        public string HPAName { get; set; }

        public string NSOID { get; set; }

        public string NSOName { get; set; }

        public string SportRankingCategoryID { get; set; }

        public string Ranking { get; set; }

        public bool HasComments { get; set; }

        public bool Editable { get; set; }
    }

    [Serializable]
    public class MaintenanceSportsGridDisciplineViewModel
    {
        public string DisciplineId { get; set; }

        public string SportCode { get; set; }

        public string Name_EN { get; set; }

        public string Name_FR { get; set; }

        public bool HasComments { get; set; }

        public bool Benchmark { get; set; }

        [UIHint("SportGenderPlusNoneTemplate")]
        public string Gender { get; set; }

        public bool MedalEvent { get; set; }
    }

    [Serializable]
    public class MaintenanceSportsGridEventViewModel
    {
        public string EventId { get; set; }

        public string SportCode { get; set; }

        public string Name_EN { get; set; }

        public string Name_FR { get; set; }

        public bool HasComments { get; set; }

        public bool Benchmark { get; set; }

        public bool TeamSport { get; set; }

        public int? TeamSize { get; set; }

        public bool ResourceTracking { get; set; }

        public bool MedalEvent { get; set; }
    }

    [Serializable]
    public class EvaluationsQuestionsEvaluationVersionGridViewModel
    {
        public int EvaluationVersionId { get; set; }

        public string OrganizationTypeId { get; set; }

        public string OrganizationTypeName { get; set; }

        public string YearId { get; set; }

        public string VersionId { get; set; }

        public string VersionPhase { get; set; }

        public string Name_EN { get; set; }

        public string Name_FR { get; set; }

        public bool HasComments { get; set; }

        public string Name { get; set; }
    }

    [Serializable]
    public class EvaluationsQuestionsEvaluationPillarsGridViewModel
    {
        public string EvaluationMasterPillarId { get; set; }

        public string EvaluationMasterPillarName { get; set; }

        public int EvaluationVersionId { get; set; }

        public string Name { get; set; }

        public string Description { get; set; }

        public int NumberOfQuestions { get; set; }
    }

    [Serializable]
    public class EvaluationsQuestionsEvaluationPillarQuestionsGridViewModel
    {
        public int EvaluationVersionQuestionId { get; set; }

        public int EvaluationVersionId { get; set; }

        public string EvaluationMasterPillarId { get; set; }

        public int EvaluationMasterQuestionId { get; set; }

        public string VersionQuestion { get; set; }

        public int SortOrder { get; set; }

        public string QuestionPhase { get; set; }

        public string SportId { get; set; }

        public string SportName { get; set; }

        public bool HasComments { get; set; }

        public bool Editable { get; set; }
    }

    [Serializable]
    public class EvaluationFormViewModel
    {
        public Evaluation Evaluation { get; set; }

        public string SportTitle { get; set; }
        public string EvaluationTitle { get; set; }

        public int SelectedTabIndex { get; set; }
        public List<string> ToolbarButtons { get; set; }

        public bool Editable { get; set; }
        public bool CanEditSportQuestions { get; set; }
    }

    [Serializable]
    public class EvaluationPillarViewModel
    {
        public int EvaluationId { get; set; }
        public string SportId { get; set; }
        public string ActionItemRatio { get; set; }

        public EvaluationPillar Pillar { get; set; }

        public bool Editable { get; set; }
        public bool InitialStatusEditable { get; set; }
        public bool CurrentStatusVisible { get; set; }
        public bool HasActionItem { get; set; }
        public bool CanEditSportQuestions { get; set; }
    }

    [Serializable]
    public class ActionItem
    {
        public int Id { get; set; }

        public string TypeId { get; set; }        //ActionItemType.Type

        public string TypeDesc { get; set; }    //ActionItemType.Category

        public string ReferenceId { get; set; }

        public string OrganizationId { get; set; }

        public string OrganizationDesc { get; set; }

        public string SportId { get; set; }

        public string SportDesc { get; set; }

        public string Description { get; set; }

        public DateTime DueDate
        {
            get;
            set;
        }

        public string Status { get; set; }

        public string StatusDesc { get; set; }

        public string Priority { get; set; }

        public string PriorityDesc { get; set; }

        public string Comment { get; set; }

        public int UserId { get; set; }

        public bool HasComment { get; set; }

        public string ControllerName { get; set; }

        public string ActionName { get; set; }

        public bool Editable { get; set; }
    }

    [Serializable]
    public class Decode
    {
        public int IntId { get; set; }
        public string Id { get; set; }
        public string CategoryId { get; set; }
        public string Name { get; set; }
        public string Comment { get; set; }
        public int SortOrder { get; set; }
    }

    [Serializable]
    public class Organization
    {
        public class Comparer : IComparer<Organization>
        {
            private string _currentOrganization;

            public Comparer(string organizationId)
            {
                this._currentOrganization = organizationId;
            }

            public int Compare(Organization x, Organization y)
            {
                if (x.Id == this._currentOrganization && y.Id == this._currentOrganization) return 0;
                if (x.Id == this._currentOrganization) return -1;
                if (y.Id == this._currentOrganization) return 1;

                return (x.Type + x.Name).CompareTo(y.Type + y.Name);
            }
        }

        public string Id { get; set; }

        public string Type { get; set; }

        public string Name { get; set; }
    }

    [Serializable]
    public class Evaluation
    {
        public int Id { get; set; }

        public int VersionId { get; set; }

        public string VersionYearId { get; set; }

        public string VersionName { get; set; }

        public string VersionPhase { get; set; }

        public string SportId { get; set; }

        public string SportDesc { get; set; }

        public string Phase { get; set; }

        public string PhaseDesc { get; set; }

        public string Comment { get; set; }

        public IEnumerable<EvaluationPillar> Pillars { get; set; }
    }

    [Serializable]
    public class EvaluationPillar
    {
        public class Comparer : IComparer<EvaluationPillar>
        {
            public int Compare(EvaluationPillar x, EvaluationPillar y)
            {
                return x.SortOrder.CompareTo(y.SortOrder);
            }
        }

        public string Id { get; set; }

        public string Name { get; set; }

        public string Description { get; set; }

        public int SortOrder { get; set; }

        public string Comment { get; set; }

        public string Id_Name { get; set; }

        public IEnumerable<EvaluationQuestion> Questions { get; set; }
    }

    [Serializable]
    public class EvaluationQuestion
    {
        public class Comparer : IComparer<EvaluationQuestion>
        {
            public int Compare(EvaluationQuestion x, EvaluationQuestion y)
            {
                return x.SortOrder.CompareTo(y.SortOrder);
            }
        }

        public int Id { get; set; }

        public int VersionQuestionId { get; set; }

        public int VersionId { get; set; }

        public int MasterQuestionId { get; set; }

        public string MasterPillarId { get; set; }

        public string SportId { get; set; }

        public string Question { get; set; }

        public string Phase { get; set; }

        public int SortOrder { get; set; }

        public bool NotApplicable { get; set; }

        public string InitialStatus { get; set; }

        public string CurrentStatus { get; set; }

        public string InitialAssessment { get; set; }

        public string CurrentAssessment { get; set; }

        public string Comment { get; set; }

        public bool HasComments { get; set; }
    }
}
